<?php
/* LARUS BOARD ========================================================
 * Encoded in UTF-8 (micro symbol: µ)
 * Copyright © 2008 by "The Larus Board Team"
 * This file is part of "Larus Board".
 *
 * "Larus Board" is free software: you can redistribute it and/or modify
 * it under the terms of the modified BSD license.
 *
 * "Larus Board" is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * You should have received a copy of the modified BSD License
 * along with this package. If not, see
 * <http://download.savannah.gnu.org/releases/larusboard/COPYING.BSD>.
 */
  if ( !defined('__XF_INCLUDE') )
  die('File "'.basename(__FILE__).'" cannot be executed directly!');

/**
* @package lbfrontend
*/
class XFAction_acp_pp_list extends XFAction {
protected $success = false;
protected $error = '';
protected $gpc = array();
protected $markgpc = array();
public $version = 0x01;

  /**
  * @param string $a select handler
  * @param array $b input data for asynchronous request
  * @return mixed
  * @since 1.0.0
  */
  public function init($a,$b){
  XFUI::load_lang_res('','acp');
  return $this->$a($b);
  }

  /**
  * @return true
  * @since 1.0.0
  */
  protected function regular(){
  $id = XF::sanitize_var(XF::ifset('get','id',0),'int');
  $this->gpc = array('id'=>$id);
  unset($id);

  $data = array();
    if ( $this->gpc['id'] !== 0 ){
    $sgrp = XF::sql_query("SELECT * FROM ".XF::tbl('post_prefix')." WHERE pp_id = :id",array(
    'id'=>array($this->gpc['id'],'int')),__METHOD__,__LINE__);
    $data = (array)$sgrp->fetchObject();
    $sgrp->closeCursor();
    $spst = XF::sql_query("SELECT COUNT(p_id) AS posts_have_this FROM ".XF::tbl('post_meta')." WHERE p_pp_id = :id",array(
    'id'=>array($this->gpc['id'],'int')),__METHOD__,__LINE__);
    $post = $spst->fetchObject();
    $data['posts_have_this'] = intval($post->posts_have_this);
    $spst->closeCursor();
    XF::tan('acp_pp_delete');
    XFUI::ajax_init();
    }

  XF::tan('acp_pp_edit');
  XFUI::html_head('{:post_prefix}');
  XF::$tpl->clear_cache('form_acp_pp.tpl');
  XF::$tpl->assign('selected_prefix',$this->gpc['id']);
  XF::$tpl->assign('prefix_listing',XFUI::get_post_prefix_list());
  XF::$tpl->assign('prefix_data',$data);
  XF::$tpl->display('form_acp_pp.tpl');
  XFUI::html_foot();
  return true;
  }

  /**
  * @since 1.0.0
  */
  protected function ajax($input){}

  /**
  * list post prefixes (done directly in run())
  * @since 1.0.0
  */
  public function execute(){}

}
?>