<?php
/* LARUS BOARD ========================================================
 * Encoded in UTF-8 (micro symbol: µ)
 * Copyright © 2008 by "The Larus Board Team"
 * This file is part of "Larus Board".
 *
 * "Larus Board" is free software: you can redistribute it and/or modify
 * it under the terms of the modified BSD license.
 *
 * "Larus Board" is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * You should have received a copy of the modified BSD License
 * along with this package. If not, see
 * <http://download.savannah.gnu.org/releases/larusboard/COPYING.BSD>.
 */
  if ( !defined('__XF_INCLUDE') )
  die('File "'.basename(__FILE__).'" cannot be executed directly!');
  if ( !class_exists('XF') )
  die('Root class is not loaded, yet!');

/**
* XFLog provides a general-purpose logging facility
* @package lbbackend
*/
class XFLog {
/**
* @var string error level
*/
protected $level = 'info';
/**
* @var string buffer for error message
*/
protected $buffer = '';
/**
* @var string ip address
*/
protected $ip = '';

  //public function __construct(){}
  //public function __destruct(){}

  /**
  * sets a logging level
  * @param string $a use level 'info' or 'error'
  * @return boolean
  * @since 1.0.0
  */
  public function set_level($a){
    if ( XF::sanitize_var($a,'enum','o=info,o=error') ){
    $this->level = $a;
    return true;
    }
    else
    return false;
  }

  /**
  * set a logging message
  * @param string $a text message, can be array
  * @return true
  * @since 1.0.0
  */
  public function set_message($a){
    if ( is_array($a) )
    $a = implode(' ',$a);
  $this->buffer = str_replace('"',"'",$a);
  return true;
  }

  /**
  * set an ip-address
  * @param string $a the ipv4 address
  * @return boolean
  * @since 1.0.0
  */
  public function set_ip($a){
    if ( XF::sanitize_var($a,'ip') ){
    $this->ip = $a;
    return true;
    }
    else
    return false;
  }

  /**
  * reset any settings
  * @return true
  * @since 1.0.0
  */
  public function reset(){
  $this->level = 'info';
  $this->buffer = '';
  $this->ip = '';
  return true;
  }

  /**
  * write a log entry to local database using prior set data
  * @return true
  * @since 1.0.0
  */
  public function log_to_db(){
  XF::sql_query("INSERT INTO ".XF::tbl('log')." (l_u_id,l_index_month,l_index_year,l_level,l_ip,l_time,l_action,l_text) VALUES (:userid,:month,:year,:level,:ip,:time,:action,:message)",
  array('userid'=>array(XF::vault_query('current_user_id'),'int'),
  'month'=>array(gmdate('m'),'int'),
  'year'=>array(gmdate('Y'),'int'),
  'level'=>array($this->level,'str'),
  'ip'=>array(ip2long($this->ip),'int'),
  'time'=>array(XF::vault_query('uts'),'int'),
  'action'=>array(XF::vault_query('request_method').','.XF::vault_query('request_action'),'str'),
  'message'=>array($this->buffer,'str')),__METHOD__,__LINE__);
  $this->reset();
  return true;
  }

}
?>