<?php
/* LARUS BOARD ========================================================
 * Encoded in UTF-8 (micro symbol: µ)
 * Copyright © 2008 by "The Larus Board Team"
 * This file is part of "Larus Board".
 *
 * "Larus Board" is free software: you can redistribute it and/or modify
 * it under the terms of the modified BSD license.
 *
 * "Larus Board" is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * You should have received a copy of the modified BSD License
 * along with this package. If not, see
 * <http://download.savannah.gnu.org/releases/larusboard/COPYING.BSD>.
 */
  if ( !defined('__XF_INCLUDE') )
  die('File "'.basename(__FILE__).'" cannot be executed directly!');
  if ( !defined('__XF_ALLOW_TASK') )
  die('Running tasks has not been allowed by XF-Core!');

/**
* @package lbbackend
*/
class XFTask_post_timespan extends XFTask {
public $version = 0x01;
protected $trace = array();

  public function setup(){
  return array(
  'default_interval'=>86400,
  'default_active'=>true
  );
  }

  public function execute(){
  $sold = XF::sql_query("SELECT p_id,p_time FROM ".XF::tbl('post_meta')." WHERE p_approved = true ORDER BY p_time ASC LIMIT 1 OFFSET 0",'',__METHOD__,__LINE__);
  $postdata_old = $sold->fetchObject();
  $sold->closeCursor();
  $snew = XF::sql_query("SELECT p_id,p_time FROM ".XF::tbl('post_meta')." WHERE p_approved = true ORDER BY p_time DESC LIMIT 1 OFFSET 0",'',__METHOD__,__LINE__);
  $postdata_new = $snew->fetchObject();
  $snew->closeCursor();
    if ( !$postdata_old || !$postdata_new )
    return false;
  XFCache::put('simple','post_timespan',array((int)$postdata_old->p_time,(int)$postdata_new->p_time));
  $this->trace[] = 'calculate oldest posting ['.$postdata_old->p_id.'] on "'.XF::date($postdata_old->p_time).'"'.
                        ' and newest posting ['.$postdata_new->p_id.'] on "'.XF::date($postdata_new->p_time).'"';
  return true;
  }

}
$_t = new XFTask_post_timespan();
?>