<?php
/* LARUS BOARD ========================================================
 * Encoded in UTF-8 (micro symbol: µ)
 * Copyright © 2008 by "The Larus Board Team"
 * This file is part of "Larus Board".
 *
 * "Larus Board" is free software: you can redistribute it and/or modify
 * it under the terms of the modified BSD license.
 *
 * "Larus Board" is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * You should have received a copy of the modified BSD License
 * along with this package. If not, see
 * <http://download.savannah.gnu.org/releases/larusboard/COPYING.BSD>.
 */
  if ( !defined('__XF_INCLUDE') )
  die('File "'.basename(__FILE__).'" cannot be executed directly!');
  if ( !defined('__XF_ALLOW_TASK') )
  die('Running tasks has not been allowed by XF-Core!');

/**
* @package lbbackend
*/
class XFTask_prune_user extends XFTask {
public $version = 0x01;
protected $trace = array();

  public function setup(){
  return array(
  'default_interval'=>900,
  'default_active'=>true
  );
  }

  public function execute(){
  XF::sql_query("UPDATE ".XF::tbl('user')." SET u_login_fail = 0 WHERE true",'',__METHOD__,__LINE__);
  $a = XF::sql_query("DELETE FROM ".XF::tbl('user')." WHERE u_active = false AND u_login_count = 0 AND u_time_registration < :threshold AND u_id != :userid",
  array(
  'userid'=>array(XF::get_cfg('main_guest_uid'),'int'),
  'threshold'=>array(intval(XF::vault_query('uts')-XF::get_cfg('auth_activate_limit')),'int')),__METHOD__,__LINE__);
  $this->trace[] = 'removed '.$a.' inactive accounts having no login and no posts submitted';
  return true;
  }

}
$_t = new XFTask_prune_user();
?>